<?php
//#################################################################################################
//	Menu-Helperfunctions
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################
//	mainmenu()
//	message($message)
//#################################################################################################

//Backendmenu//////////////////////////////////////////////////////////////////////////////////////
function mainmenu() {
	global $l_menu,$mysession,$is_admin;
	$gids = $mysession->user->gids;
	//what is the active site?
	$activebackendsite=substr($_SERVER["SCRIPT_FILENAME"],strlen(PATH."/admin/"));
	$activebackendsite=substr($activebackendsite,0,-9);

	echo "<div class='adminmenu'>\n".
	"\t<div class='adminmenu_left'></div>\n".
	"\t<div class='adminmenu_middle'>\n".
	"\t<ul>\n";
	//settings
	if ($is_admin) {
		echo "\t\t<li>";
		if ($activebackendsite=="settings") { echo "<div class='active'>"; }
		echo "<a class='menu_settings' href='../admin/settings.site.php'>$l_menu[lbl_settings]</a>";
		if ($activebackendsite=="settings") { echo "</div>"; }
		echo "</li>\n";
	}
	//content
	echo "\t\t<li>";
	if ($activebackendsite=="content" or $activebackendsite=="edit") { echo "<div class='active'>"; }
	echo "<a class='menu_content' href='../admin/content.site.php'>$l_menu[lbl_content]</a>";
	if ($activebackendsite=="content" or $activebackendsite=="edit") { echo "</div>"; }
	//media
	echo "</li>\n\t\t<li>";
	if ($activebackendsite=="media") { echo "<div class='active'>"; }
	echo "<a class='menu_media' href='../admin/media.site.php'>$l_menu[lbl_media]</a>";
	if ($activebackendsite=="media") { echo "</div>"; }
	echo "</li>\n";
	//modules
	if ($is_admin) {
		echo "\t\t<li>";
		if ($activebackendsite=="modules" or $activebackendsite=="moduleinfo" or $activebackendsite=="modulesedit")
		{ echo "<div class='active'>"; }
		echo "<a class='menu_modules' href='../admin/modules.site.php'>$l_menu[lbl_modules]</a>";
		if ($activebackendsite=="modules" or $activebackendsite=="moduleinfo" or $activebackendsite=="modulesedit")
		{ echo "</div>"; }
		echo "</li>\n";
	}
	//design
	if ($is_admin) {
		echo "\t\t<li>";
		if ($activebackendsite=="design") { echo "<div class='active'>"; }
		echo "<a class='menu_design' href='../admin/design.site.php'>$l_menu[lbl_design]</a>";
		if ($activebackendsite=="design") { echo "</div>"; }
		echo "</li>\n";
	}
	//users/groups
	echo "\t\t<li>";
	if ($activebackendsite=="usersgroups" or $activebackendsite=="userform" or $activebackendsite=="groupform")
	{ echo "<div class='active'>"; }
	echo "<a class='menu_usersgroups' href='../admin/usersgroups.site.php'>$l_menu[lbl_usersgroups]</a>";
	if ($activebackendsite=="usersgroups" or $activebackendsite=="userform" or $activebackendsite=="groupform") { echo "</div>"; }
	//tools
	echo "</li>\n\t\t<li>";
	if ($activebackendsite=="tools") { echo "<div class='active'>"; }
	echo "<a class='menu_tools' href='../admin/tools.site.php'>$l_menu[lbl_tools]</a>";
	if ($activebackendsite=="tools") { echo "</div>"; }

	echo "</li>\n\t\t<li class='menu_small'><a class='menu_logout' href='../admin/login.site.php?".
	"action=logout&amp;reason=logout'>$l_menu[lbl_logout]</a></li>\n".
	"\t\t<li class='menu_small'><a class='menu_preview' href='../core/show.site.php' ".
	"target='_blank'>$l_menu[lbl_preview]</a></li>\n".
	"\t</ul>\n".
	"\t</div>\n".
	"\t<div class='adminmenu_right'></div>\n".
	"</div>\n";
}
function message($message) {
	if (is_array($message) && sizeof($message)==2) {
		$msg=escape_html($message[0]);
		$type=escape_html($message[1]);
		echo "\t\t\t<div class='message'>\n";
		if ($type!="" && $msg!="") {
			echo "\t\t\t\t<div class='message_left_".$type."'></div>\n";
			echo "\t\t\t\t<p class='$type'>$msg</p>\n";
			echo "\t\t\t\t<div class='message_right_".$type."'></div>\n";
		}
		echo "\t\t\t</div>\n";
	}
}
?>
