<?php
//#################################################################################################
//	Tools helper functions
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################
//	tools_menu($tool)
//	backup_form()
//	newsletter_form()
//	analysis_form()
//	backup_now()
//	delete_backup($name)
//	reset_stats($which)
//	send_newsletter()
//#################################################################################################

//Tools menu///////////////////////////////////////////////////////////////////////////////////////
function tools_menu($tool) {
	global $is_admin;
	$analysis=$newsletter=$backup="";
	if	($tool=="backup")	{	$analysis="_no";	$newsletter="_no";	}
	elseif	($tool=="newsletter")	{	$analysis="_no";	$backup="_no";		} 
	else				{	$backup="_no";		$newsletter="_no";	}
	$toolsmenu = "\t\t<ul class='toolsmenu'>\n".
	//analysis
	"\t\t\t<li>\n".
	"\t\t\t\t<form method='post' action='tools.site.php'>\n".
	"\t\t\t\t\t<input type='hidden' name='tool' value='analysis' />\n".
	"\t\t\t\t\t<input type='submit' class='linkbutton tools_analysis$analysis' value=''/>\n".
	"\t\t\t\t\t<span>Analysis-Tools</span>\n".
	"\t\t\t\t</form>\n".
	"\t\t\t</li>\n".
	//newsletter
	"\t\t\t<li>\n".
	"\t\t\t\t<form method='post' action='tools.site.php'>\n".
	"\t\t\t\t\t<input type='hidden' name='tool' value='newsletter' />\n".
	"\t\t\t\t\t<input type='submit' class='linkbutton tools_newsletter$newsletter' value=''/>\n".
	"\t\t\t\t\t<span>Newsletter</span>\n".
	"\t\t\t\t</form>\n".
	"\t\t\t</li>\n";
	//backup
	if ($is_admin) {
		$toolsmenu .= "\t\t\t<li>\n".
		"\t\t\t\t<form method='post' action='tools.site.php'>\n".
		"\t\t\t\t\t<input type='hidden' name='tool' value='backup' />\n".
		"\t\t\t\t\t<input type='submit' class='linkbutton tools_backup$backup' value=''/>\n".
		"\t\t\t\t\t<span>Backup</span>\n".
		"\t\t\t\t</form>\n".
		"\t\t\t</li>\n";
	}
	$toolsmenu .= "\t\t</ul>\n".
	"\t\t<div class='tool'>\n";
	if	($tool=="backup")	{ $toolsmenu .= backup_form();		}
	elseif	($tool=="newsletter")	{ $toolsmenu .= newsletter_form();	}
	else				{ $toolsmenu .= analysis_form();	}
	$toolsmenu .= "\t\t\t<br /><br />\n".
	"\t\t</div>\n".
	"\t\t<div class='clr'></div>\n";
	
	return $toolsmenu;	
}
//Backup tool//////////////////////////////////////////////////////////////////////////////////////
function backup_form() {
	global $is_admin,$l_tools,$l_gen,$backendstyle;
	
	$backupform = "";
	if ($is_admin) {
		$backupform .= "\t\t\t<h1>$l_tools[lbl_managebus]</h1>\n".
		//former backups:
		"\t\t\t<table cellspacing='0' width='100%'>\n".
		"\t\t\t<tr>\n".
		"\t\t\t\t<th class='left'>$l_tools[lbl_name]</th>\n".
		"\t\t\t\t<th class='left'>$l_tools[lbl_date]</th>\n".
		"\t\t\t\t<th class='center'>$l_tools[lbl_filesize]</th>\n".
		"\t\t\t\t<th class='center'>$l_gen[lbl_download]</th>\n".
		"\t\t\t\t<th class='center'>$l_gen[lbl_delete]</th>\n".
		"\t\t\t</tr>\n";
		$style="even";
		//read all files beginning with backup_ and ending with .zip
		$files=read_files(PATH."/backup");
		//order: new to old
		rsort($files);
		foreach ($files as $file) {
			//only show real backup files
			if (substr($file["name"],0,7)=="backup_" && substr($file["name"],-4)==".zip") {
				$date=substr(substr($file["name"],-19),0,-4);
				$time=substr($date,-6);
				$hr=substr($time,0,2);
				$min=substr($time,2,2);
				$sec=substr($time,-2);
				$date=substr($date,0,-7);
				$day=substr($date,-2);
				$month=substr($date,4,2);
				$yr=substr($date,0,4);
				$filesize=round($file["size"]/1000000, 2);
				//name
				$backupform .= "\t\t\t<tr class='$style'>\n".
				"\t\t\t\t<td class='left'>$file[name]</td>\n".
				//date
				"\t\t\t\t<td class='left'>$yr/$month/$day $hr:$min:$sec</td>\n".
				//size
				"\t\t\t\t<td class='center'>$filesize MB</td>\n".
				//download button
				"\t\t\t\t<td>\n".
				"\t\t\t\t\t<form action='http://".URL."/backup/$file[name]'>\n".
				"\t\t\t\t\t\t<input type='submit' class='save' title='$l_gen[lbl_download]' />\n".
				"\t\t\t\t\t</form>\n".
				"\t\t\t\t</td>\n".
				//delete button
				"\t\t\t\t<td>\n".
				"\t\t\t\t\t<form method='post' action='tools.site.php'>\n".
				"\t\t\t\t\t\t<input type='hidden' name='tool' value='backup' />\n".
				"\t\t\t\t\t\t<input type='hidden' name='action' value='delete' />\n".
				"\t\t\t\t\t\t<input type='hidden' name='name' value='$file[name]' />\n".
				"\t\t\t\t\t\t<input type='submit' class='delete' title='$l_gen[lbl_delete]' ".
				js_confirm_link($file["name"].$l_gen["pop_del"])." />\n".
				"\t\t\t\t\t</form>\n".
				"\t\t\t\t</td>\n".
				"\t\t\t</tr>\n";
				if ($style=="odd") { $style="even"; } else { $style="odd"; }
			}
			
		}
		$backupform .= "\t\t\t</table><br /><br />\n";
		//backup now button
		$backupform .= "\t\t\t<form method='post' action='tools.site.php'>\n".
		"\t\t\t\t<input type='hidden' name='action' value='backupnow'></input>\n".
		"\t\t\t\t<input type='hidden' name='tool' value='backup'></input>\n".
		"\t\t\t\t<input type='submit' value='$l_tools[lbl_backupnow]'></input>\n".
		"\t\t\t</form>\n";
	}
	
	return $backupform;
}
//Newsletter tool//////////////////////////////////////////////////////////////////////////////////////
function newsletter_form() {
	global $l_tools,$settings,$l_gen,$l_ugs,$l_gform,$page;
	$newsletterform = "<h1>".$l_tools["lbl_newsletter"]."</h1><br />".
	"<form method='post' action='tools.site.php'>".
	"<table class='newslettertable1' cellspacing='0'>".
	//From
	"<tr><td>$l_tools[lbl_from]</td><td>\"$settings[sitename]\" &lt;$settings[siteemail]&gt;</td></tr>".
	"<input type='hidden' name='from1' value='$settings[sitename]'></input>".
	"<input type='hidden' name='from2' value='$settings[siteemail]'></input>".
	//Subject
	"<tr><td>$l_tools[lbl_subject]</td><td><input type='text' name='subject' /></td></tr>".
	//Message
	"<tr><td>$l_tools[lbl_message]</td><td></td></tr>".
	"</table>".
	//Extra Buttons
	"<div class='floatright'>".
	"<input class='button' type='submit' name='action' value='$l_tools[lbl_sendnl]'/></input>".
	"<input type='reset' name='action' value='$l_gen[lbl_reset]'/>".
	"</div>".
	//To	//TODO: an registrierte user
	"<table class='newslettertable2' cellspacing='0'>".
	"<tr><th width='20px'></th><th width='20px'></th><th width='130px'>$l_tools[lbl_to]</th></tr>";
	$allgroups=db_query("select * from system_groups order by name asc");
	$page->query();
	foreach ($allgroups as $g) {
		if ($g["gid"]==1) { $symbol="<a class='admin'></a>"; $g["name"]=$l_gform["lbl_admins"]; }
		elseif ($g["gid"]==2) { $symbol="<a class='user'></a>"; $g["name"]=$l_ugs["lbl_users"]; }
		else { $symbol="<a class='special'></a>"; }
		$newsletterform .= "<tr><td><input type='checkbox' class='middle' name='mailto[]' value='$g[gid]'/></td>".
		"<td>$symbol</td><td class='mailtoname'>$g[name]</td></tr>";
	}
	$newsletterform .= "</table>".
	"<div class='newslettercontent'><br />".
	"<div>".
	"<textarea name='ckeditor' rows='25' style='width:95%'></textarea>".
	"<div class='clr'></div>".
	"<a class='editorswitch' href='javascript:;'". 
	"onmousedown=\"CKEDITOR.replace('ckeditor');\">WYSIWYG</a>".
	"<a class='editorswitch' href='javascript:;' onmousedown=\"CKEDITOR.instances.".
	"ckeditor.destroy();\">HTML</a>".
	"<br />".
	"</div><br />".
	"</div>".
	"<script type='text/javascript'>".
		"CKEDITOR.replace( 'ckeditor', {".
			"toolbar : 'Newsletter' }".
		");".
	"</script>".
	"<input type='hidden' name='tool' value='newsletter'></input>".
	"</form>";
	
	return $newsletterform;
}
//Analysis tool//////////////////////////////////////////////////////////////////////////////////////
function analysis_form() {
	global $l_tools,$l_uform,$l_edit,$is_admin,$l_ctr,$l_gen,$page;
	$analysisform = "<h1>$l_tools[lbl_stats]</h1>".
	//Top 10 Contents
	"<div class='analysis_left'>".
	"<h2 style='float:left'>$l_tools[lbl_top10a]</h2>";
	//reset
	if ($is_admin) {
		$analysisform .= "<form method='post' action='tools.site.php?tool=analysis'>".
		"<input type='hidden' name='action' value='reset' />".
		"<input type='hidden' name='table' value='content' />".
		"<input type='submit' class='floatright' value='$l_gen[lbl_reset]' /></form>";
	}
	$analysisform .= "<br />".
	"<table cellspacing='0' width='100%' style='float:left'><tr>".
	"<th class='center'>#</th>".
	"<th class='left'>$l_edit[lbl_name]</th>".
	"<th class='center'>$l_tools[lbl_views]</th></tr><br>";
	$result=db_query_array("select name,views from site_content where depth>0 and views>0 order by views desc limit 10");
	$page->query();
	$style="odd";
	$i=0;
	foreach ($result as $row) {
		$i++;
		$analysisform .= "<tr class='$style'><td>$i</td><td class='left'>$row[name]</td><td>$row[views]</td></tr>";
		if ($style=="odd") { $style="even"; } else { $style="odd"; }
	}
	$analysisform .= "</table></div>";
	if ($is_admin) {
		//Top 10 Most active Users
		$analysisform .= "<div class='analysis_right'>".
		"<h2 style='float:left'>$l_tools[lbl_top10u]</h2>".
		"<form method='post' action='tools.site.php?tool=analysis'>".
		"<input type='hidden' name='action' value='reset' />".
		"<input type='hidden' name='table' value='users' />".
		"<input type='submit' class='floatright' value='$l_gen[lbl_reset]' /></form>".
		"<br />".
		"<table cellspacing='0' width='100%' style='float:left'><tr>".
		"<th class='center'>#</th>".
		"<th class='left'>$l_uform[lbl_uname]</th>".
		"<th class='left'>$l_uform[lbl_name]</th>".
		"<th class='center'>$l_uform[lbl_logins]</th></tr><br>";
		$result=db_query_array("select user,name,logins from system_users where logins>0 order by logins desc limit 10");
		$page->query();
		$style="odd";
		$i=0;
		foreach ($result as $row) {
			$i++;
			$analysisform .= "<tr class='$style'><td>$i</td><td class='left'>$row[user]</td>".
			"<td class='left'>$row[name]</td><td>$row[logins]</td></tr>";
			if ($style=="odd") { $style="even"; } else { $style="odd"; }
		}
		$analysisform .= "</table></div>";
	}
	$analysisform .= "<div class='clr'></div>";
	//Webstats
	$allwebstats=db_query_array("select * from site_visitors");
	$page->query();
	$visits=0;
	$browsers=$oss=$countries=array();
	foreach($allwebstats as $ws) {
		//--visits
		$visits+=$ws["visits"];
		//--browsers
		$monthbrowsers=explode(",",$ws["browsers"]);
		foreach($monthbrowsers as $mb) {
			$var=explode(":",$mb);
			if ($var[0]!="") {
				$browsers[$var[0]]+=intval($var[1]);
			}
		}
		//--oss
		$monthoss=explode(",",$ws["oss"]);
		foreach($monthoss as $mo) {
			$var=explode(":",$mo);
			if ($var[0]!="") {
				$oss[$var[0]]+=intval($var[1]);
			}
		}
		//--countries
		$monthc=explode(",",$ws["countries"]);
		foreach($monthc as $mc) {
			$var=explode(":",$mc);
			if ($var[0]!="") {
				$countries[$var[0]]+=intval($var[1]);
			}
		}
	}
	//sort results
	arsort($browsers, SORT_NUMERIC);
	arsort($oss, SORT_NUMERIC);
	arsort($countries, SORT_NUMERIC);
	//output
	//--visits
	$analysisform .= "<div class='analysis_left'><h2 class='floatleft'>$l_tools[lbl_visits]<br /><br />$visits</h2>";
	//reset
	if ($is_admin) {
		$analysisform .= "<form method='post' action='tools.site.php?tool=analysis'>".
		"<input type='hidden' name='action' value='reset' />".
		"<input type='hidden' name='table' value='visits' />".
		"<input type='submit' class='floatright' value='$l_gen[lbl_reset]' /></form>";
	}
	$analysisform .= "</div>".
	//--browsers
	"<div class='analysis_right'><h2 class='floatleft'>$l_tools[lbl_browsers]</h2>".
	"<br /><table cellspacing='0' width='100%'>".
	"<tr><th class='left'>$l_tools[lbl_browser]</th>".
	"<th class='center'>$l_tools[lbl_amount]</th>".
	"<th class='center'>$l_tools[lbl_percent]</th></tr>";
	$style="odd";
	$counter=0;
	foreach ($browsers as $browser=>$amount) {
		if ($counter==9) { break; } else { $counter++; }
		$analysisform .= "<tr class='$style'><td class='left'>".ucfirst($browser)."</td><td>$amount</td><td>".
		round($amount/$visits*100,1)."%</td></tr>";
		if ($style=="odd") { $style="even"; } else { $style="odd"; }
	}
	$analysisform .= "</table></div>".
	"<div class='clr'></div>";
	//--oss
	$analysisform .= "<div class='analysis_right'><h2 class='floatleft'>$l_tools[lbl_oss]</h2>".
	"<br /><table cellspacing='0' width='100%'>".
	"<tr><th class='left'>$l_tools[lbl_os]</th>".
	"<th class='center'>$l_tools[lbl_amount]</th>".
	"<th class='center'>$l_tools[lbl_percent]</th></tr>";
	$style="odd";
	$counter=0;
	foreach ($oss as $os=>$amount) {
		if ($counter==9) { break; } else { $counter++; }
		$analysisform .= "<tr class='$style'><td class='left'>$os</td><td>$amount</td><td>".round($amount/$visits*100,1)."%</td></tr>";
		if ($style=="odd") { $style="even"; } else { $style="odd"; }
	}
	$analysisform .= "</table></div>".
	//--countries
	"<div class='analysis_left'><h2 class='floatleft'>$l_tools[lbl_countries]</h2>".
	"<br /><table cellspacing='0' width='100%'>".
	"<tr><th class='left'>$l_tools[lbl_country]</th>".
	"<th class='center'>$l_tools[lbl_amount]</th>".
	"<th class='center'>$l_tools[lbl_percent]</th></tr>";
	$style="odd";
	$counter=0;
	foreach ($countries as $c=>$amount) {
		if ($counter==9) { break; } else { $counter++; }
		$analysisform .= "<tr class='$style'><td class='left'>$l_ctr[$c]</td><td>$amount</td><td>".
		round($amount/$visits*100,1)."%</td></tr>";
		if ($style=="odd") { $style="even"; } else { $style="odd"; }
	}
	$analysisform .= "</table></div>".
	"<div class='clr'></div>";
	//--Feedback about chillyCMS
	$showfeedback=false;
	$loginmods=db_query_array("select settings from site_modules where modid=3");
	$page->query();
	foreach ($loginmods as $l) {
		$settings=explode(",",$l["settings"]);
		if ($settings[4]==1) { $showfeedback=true; }
	}
	//show only if there is at least one login module with activated feedback
	if ($showfeedback) {
		//Calculation of the amount of positive feedback, negative feedback and overall feedback:
		$negative_amount=0;
		$sql="select * from mod_login";
		$result=db_query_array($sql);
		$page->query();
		if ($result) {
			foreach ($result as $row) {
				if ($row["type"]==0) {
					$positive_amount=intval($row["feedback"]);	
				} else {
					$negative_amount++;
				}
			}
		}
		$complete_amount=$positive_amount+$negative_amount;
		//Is there a feedback at all?...
		//...yes, then display the result-area:
		if ($complete_amount>0) {
			$positive_width=(($positive_amount*100)/$complete_amount);
			$negative_width=100-$positive_width;
			$pw_rounded=round($positive_width, 2);
			$nw_rounded=round($negative_width, 2);
			$feedbackinfo=$l_tools["lbl_feedbacknum"].$complete_amount;
			$display_or_not="display: block;";
		//...no, then hide the result-area:
		} else {
			$pw_rounded=$nw_rounded=$positive_width=0;
			$feedbackinfo=$l_tools["lbl_nofbyet"];
			$display_or_not="display: none;";
		}
		//build up the result-area:
		$analysisform .= "<div class='analysis_left'><h2 class='floatleft'>$l_tools[lbl_feedback]</h2>";
		//reset
		if ($is_admin) {
			$analysisform .= "<form method='post' action='tools.site.php?tool=analysis'>".
			"<input type='hidden' name='action' value='reset' />".
			"<input type='hidden' name='table' value='feedback' />".
			"<input type='submit' class='floatright' value='$l_gen[lbl_reset]' /></form>";
		}
		$analysisform .= "<br /><br /><p class='left'>".$feedbackinfo."</p><br />".
		"<div class='allocation' style='".$display_or_not."'>".
		"<span class='floatleft'>".$pw_rounded."% $l_tools[lbl_pos]</span>".
		"<span class='floatright'>".$nw_rounded."% $l_tools[lbl_neg]</span><br />".
		"<div class='complete_feedback' style='background-color: red;'>".
		"<div class='positive_feedback' style='width: ".$positive_width."%; background-color: green;'></div>".
		"</div>".
		"</div>".
		"</div><br />";
	}
	
	return $analysisform;
}
//Backup function//////////////////////////////////////////////////////////////////////////////////
function backup_now() {
	global $is_admin,$l_tools,$page;
	if ($is_admin) {
		//copy backup.zip and rename it to newly generated filename
		$myurl=no_colons(DB_HOST);
		$date=date("_Ymd_Gis");
		//if the hour begins with a zero (which is left out) insert that zero
		if (strlen($date)<16) { $date=date("_Ymd_0Gis"); }
		$file_dest=PATH."/backup/backup_".$myurl.$date.".zip";
		//make db backup
		$drop="";
		$allqueries="";
		$coretables=array("system_users","system_groups","system_modules","site_settings",
		"site_content","site_modules","site_visitors");
		//modtables
		$coretables[]="mod_login";
		$coretables[]="mod_download";
		$coretables[]="mod_guestbook";
		$db=new Database();
		//get ALL tables
		$db->query("select TABLE_NAME from information_schema.TABLES ".
		"where TABLE_SCHEMA='$db->database' order by CREATE_TIME;");
		$page->query();
		$alltables=$db->getdata_array();
		foreach ($alltables as $t) {
			$table = $t["TABLE_NAME"];
			$db->query("select * from $table");
			$page->query();
			$tablecontent = $db->getdata_array();
			$db->query("show create table $table");
			$page->query();
			$createtable = $db->getdata();
			//first add "drop if exists"-part
			if (!in_array($table,$coretables)) {
				$drop.="drop table if exists $table;\n";
			}
			//then add create table part
			$allqueries.=$createtable["Create Table"].";\n";
			//go through each table
			if (!empty($tablecontent)) {
				$tablequery=array();
				$tablecolumns=array();
				$counter=0;
				foreach ($tablecontent as $row) {
					//get column names of the table
					if ($counter==0) { 
						foreach ($row as $k=>$v) { $tablecolumns[]=$k; }
						$counter++;
					}
					//collect each row
					$insertvalues=array_map('mysql_escape_string',$row);
					$tablequery[] = "('".implode("','",$insertvalues)."')";
				}
				//make insertstring for this table
				$tablequery="insert into $table (`".implode("`,`",$tablecolumns)."`) values\n".implode(",\n",$tablequery).";\n\n";
				$allqueries.=$tablequery;
			}
		}
		//make the insert script
		$zip=new Zipper();
		$open = $zip->open($file_dest, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE);
		if ($open===true) {
			//save the script inside the zip file's installation folder
			if (!$zip->addFromString("installation/database.sql", $drop.$allqueries)) {
				return array("could not create insert-script", "bad");
			}
		} else {
			return array($l_tools["msg_accessbu"], "bad");
		}
		//copy all folders in CMSFOLDER into the zip file
		$error=false;
		if (!$zip->addDir(PATH."/admin", "admin")) { $error=true; }
		if (!$zip->addDir(PATH."/core", "core")) { $error=true; }
		if (!$zip->addDir(PATH."/languages", "languages")) { $error=true; }
		if (!$zip->addDir(PATH."/media", "media")) { $error=true; }
		if (!$zip->addDir(PATH."/modules", "modules")) { $error=true; }
		if (!$zip->addDir(PATH."/scripts", "scripts")) { $error=true; }
		if (!$zip->addDir(PATH."/style", "style")) { $error=true; }
		if (!$zip->addDir(PATH."/templates", "templates")) { $error=true; }
		//make new backup and installation folder
		if (!$zip->addDir(PATH."/backup/files", "backup/files")) { $error=true; }
		if (!$zip->addDir(PATH."/backup/files/installation", "installation")) { $error=true; }
		//copy files to cms root folder that MUST exist
		if (!$zip->addFile(PATH."/backup/files/config.php", "config.php")) { $error=true; }
		if (!$zip->addFile(PATH."/index.php", "index.php")) { $error=true; }
		//copy files to cms root folder that MIGHT exist
		if (file_exists(PATH."/description.txt")) {
			$zip->addFile(PATH."/description.txt", "description.txt");
		}
		if (file_exists(PATH."/htaccess.txt")) {
			$zip->addFile(PATH."/htaccess.txt", "htaccess.txt");
		} elseif (file_exists(PATH."/.htaccess")) {
			$zip->addFile(PATH."/.htaccess", ".htaccess");
		}
		if (file_exists(PATH."/LICENSE.txt")) {
			$zip->addFile(PATH."/LICENSE.txt", "LICENSE.txt");
		}
		if (file_exists(PATH."/CHANGELOG.txt")) {
			$zip->addFile(PATH."/CHANGELOG.txt", "CHANGELOG.txt");
		}
		//close zipfile and save
		if (!$zip->close()) { $error=true; }
		if (!$error) {
			return array($l_tools["msg_backup_ok"], "good");
		} else {
			return array($l_tools["msg_backup_err"], "bad");
		}
	}
}
//Delete a backup file/////////////////////////////////////////////////////////////////////////////
function delete_backup($name) {
	global $is_admin,$l_tools;
	if ($is_admin) {
		$name=cut_doubledots($name);
		if (@unlink(PATH."/backup/".$name)) {
			return array($l_tools["msg_delbu_ok"]." $name", "good");
		} else {
			return array($l_tools["msg_delbu_err"]." $name", "bad");
		}
	}
}
//Reset statistics/////////////////////////////////////////////////////////////////////////////////
function reset_stats($which) {
	global $l_tools,$is_admin,$page;
	$error=false;
	if ($is_admin) {
		$db=new Database();
		if (!$db->query("start transaction")) { $error=true; }
		$page->query();
		if ($which=="content") {
			if (!$db->query("update site_content set views=0")) { $error=true; }
			$page->query();
		} elseif ($which=="users") {
			$sql="update system_users set logins=0,lastlogin='0000-00-00 00:00:00'";
			if (!$db->query($sql)) { $error=true; }
			$page->query();
		} elseif ($which=="visits") {
			$sql = "update site_visitors set `visits`=0, `browsers`=null,`oss`=null,`countries`=null";
			if (!$db->query($sql)) { $error=true; }
			$page->query();
		} elseif ($which=="feedback") {
			if (!$db->query("update mod_login set feedback=0 where id=1")) { $error=true; }
			$page->query();
			if (!$db->query("delete from mod_login where id>1")) { $error=true; }
			$page->query();
		}
		if (!$error) {
			$msg = array($l_tools["msg_reset_ok"],"good");
			$sql="commit";
		} else {
			$msg = array($l_tools["msg_reset_err"],"bad");
			$sql="rollback";
		}
		while(1) {
			if ($db->query($sql)) { $page->query(); break; }
		}
		$db->close();
	}
	return $msg;
}
//Send a newsletter////////////////////////////////////////////////////////////////////////////////
function send_newsletter() {
	global $l_tools,$page;
	//from
	$from = "\"".$_POST["from1"]."\" <".email_chars($_POST["from2"]).">";

	//recipients:
	//--members of a group who want to get the newsletter
	$groups=$_POST["mailto"];
	$bcc=array();
	if (is_array($groups) && !empty($groups)) {
		$allusers=db_query_array("select email,gids from system_users where getnewsletter=1");
		$page->query();
		if (!empty($allusers)) {
			foreach ($allusers as $u) {
				$gids=explode(",",$u["gids"]);
				foreach ($groups as $g) {
					if (in_array($g,$gids)) { $bcc[] = $u["email"]; }
				}
			}
			
		}
	}
	$bcc=implode(", ",$bcc);
	$recipient = email_chars($_POST["from2"]);
	//--guests who registered for the newsletter	TODO

	//subject
	$subject = $_POST["subject"];
	if ($subject=="") { $subject=$l_tools["lbl_newsletter"]; }

	//message			TODO insert images
	$message = "<html>\n".
	"<head><title>$subject</title></head>\n".
	"<body>\n".$_POST["ckeditor"]."\n</body>\n".
	"</html>";

	//html mail header
	$header = "MIME-Version: 1.0\r\n";
	$header.= "Content-type: text/html; charset=iso-8859-1\r\n";
	if (!empty($bcc)) { $header.= "Bcc: $bcc\r\n"; }
	$header.= "From: $from"."\r\n";

	//send mail	TODO framework phpmailer
	if (mail($recipient, $subject, $message, $header)) {
		return array($l_tools["msg_nl_ok"], "good");
	} else {
		return array($l_tools["msg_nl_err"], "bad");
	}
}
?>
