<?php
//#################################################################################################
//	Page class
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################

require_once("database.class.php");
require_once("helpers.include.php");

class Frontendpage extends Page {
	//Class variables//////////////////////////////////////////////////////////////////////////

	//Functions////////////////////////////////////////////////////////////////////////////////
	//Constructor
	function __construct() {
		global $settings,$title;
		$this->num_queries	= 0;
		$this->start_time	= microtime(true);
		$this->stop_time	= false;
		$this->load_time	= false;

		//doctype
		$this->doctype = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" ".
		"\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n".
		"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".$settings["language"]."\" ".
		"lang=\"".$settings["language"]."\">\n".
		"<head>\n";

		//metatags
		$this->meta .= "\t<meta http-equiv=\"Content-Type\" content=\"text/html;charset=iso-8859-1\" />\n".
		"\t<meta name=\"Content-Language\" content=\"".$settings["language"]."\" />\n";
	
	
		"\t<meta name=\"author\" content=\"".$settings["author"]."\" />\n".
		"\t<meta name=\"keywords\" content=\"".$settings["keywords"]."\" />\n".
		"\t<meta name=\"description\" content=\"".$settings["description"]."\" />\n".
	
	
		"\t<link rel=\"icon\" href=\"../style/images/favicon.ico\" type=\"image/vnd.microsoft.icon\"/>\n".	//TODO
		"\t<meta name=\"robots\" content=\"noindex,nofollow\" />\n";						//TODO
	}
	//Destructor
	function __destruct() {
		$this->doctype=$this->title=$this->meta=$this->stylesheets=$this->scripts=$this->num_queries=
		$this->start_time=$this->stop_time=$this->load_time=false;	
	}
	//Getter
	public function __get($name) {
		if (isset($name, $this->$name)) { return $this->$name; }
		else { return false; }	
	}
} ?>
