<?php
//#################################################################################################
//	HTML functions
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################
//	head($style,$script)
//	pagestart($style,$script)
//	wrapper($msg)
//	pagestart_backend($msg,$script)
//	pagestart_login($msg,$script)
//	pagestart_installation($msg,$script)
//	pageend()
//	pageend_backend()
//#################################################################################################

if (file_exists("../config.php")) { require_once("../config.php"); }
else { require_once("../../config.php"); }
if (defined('DB_HOST')) {
	require_once(PATH."/core/settings.include.php");
	require_once(PATH."/languages/$settings[language].php");
}
require_once(PATH."/admin/menu.include.php");

//Pageheader///////////////////////////////////////////////////////////////////////////////////////
function head($style,$scripts,$title="") {
global $settings; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php echo $settings['language']; ?>" lang="<?php echo $settings['language']; ?>">
<head>
	<?php if ($title=="") {
		echo "<title>".$settings["pagetitle"]."</title>\n";
	} else {
		echo "<title>$title</title>\n";
	}?>
	<meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1" />
	<meta name="robots" content="noindex,nofollow" />
	<meta name="Content-Language" content="<?php echo $settings['language']; ?>" />
	<meta name="author" content="<?php echo $settings['author']; ?>" />
	<meta name="keywords" content="<?php echo $settings['keywords']; ?>" />
	<meta name="description" content="<?php echo $settings['description']; ?>" />
	<link rel='icon' href='../style/images/favicon.ico' type='image/vnd.microsoft.icon'/>

<?php
	if (is_array($style)) {
		foreach ($style as $s) {
			echo "\t<link rel='stylesheet' href='http://".URL.
			"/style/css/$s.css' type='text/css' />\n";
		}
	} else {
		echo "\t<link rel='stylesheet' href='http://".URL.
		"/style/css/$style.css' type='text/css' />\n";
	}
	if ($scripts!="") {
		if (is_array($scripts)) {
			foreach ($scripts as $script) {
				echo "\t<script type='text/javascript' src='../scripts/$script'></script>\n";
			}
		} elseif ($scripts=="ckeditor") {
			echo "\t<script type='text/javascript' src='../scripts/specialrightsmenu.js'></script>\n".
			"\t<script type='text/javascript' src='../modules/ckeditor/ckeditor.js'></script>\n";
		} else {
			echo "\t<script type='text/javascript' src='../scripts/$scripts'></script>\n";
		}
	}
echo "</head>";
}
//Full Pagestart///////////////////////////////////////////////////////////////////////////////////
function pagestart($style,$scripts,$title="") {
	global $settings;
	head($style,$scripts,$title);
	echo ("\n<body>\n");
}
//Backend Wrapper//////////////////////////////////////////////////////////////////////////////////
function wrapper($msg) {
	echo "\t<div class='wrapper_top'>\n".
	"\t\t<div class='wrapper_top_left'></div>\n".
	"\t\t<div class='wrapper_top_middle'>\n";
	message($msg);
	echo "\t\t</div>\n".
	"\t\t<div class='wrapper_top_right'></div>\n".
	"\t</div>\n".
	"\t<div class='clr'></div>\n".
	"\t<div class='admincontent'>\n";
}
//Admin Pagestart//////////////////////////////////////////////////////////////////////////////////
function pagestart_backend($msg,$scripts) {
	global $settings;
	$styles=array("backend",$settings["backendstyle"]);
	pagestart($styles,$scripts,"chillyCMS Backend");
	//TODO
	if (intval($settings["debug_mode"])==1) {
		ini_set('display_errors',1);
		error_reporting(E_ALL);
		echo "<div class='debug'>\n".
		"<strong>::: <em>chillyCMS</em> Debug Mode :::</strong>".	
		"</div>\n";
	}
	echo "<div class='wrapper'>\n";
	mainmenu();
	echo "<div class='mainbackend'>\n";
	wrapper($msg);
}
//Login Pagestart//////////////////////////////////////////////////////////////////////////////////
function pagestart_login($msg,$scripts) {
	global $settings;
	$styles=array("backend",$settings["backendstyle"]);
	pagestart($styles,$scripts,"chillyCMS Backend Login");
	echo "<div class='wrapper'>\n".
	"<div class='mainbackend'>\n".
	"<div class='loginmargin'></div>\n";
	wrapper($msg);
}
//Installation Pagestart///////////////////////////////////////////////////////////////////////////
function pagestart_installation($msg,$scripts) {
	pagestart("installation",$scripts);
	echo "<div class='wrapper'>\n";
	wrapper($msg);
}
//Pageend//////////////////////////////////////////////////////////////////////////////////////////
function pageend() {?>
</body>
</html>
<?php
}
//Pageend Backend//////////////////////////////////////////////////////////////////////////////////
function pageend_backend($showfooter=true) {
	global $settings;
	echo "\t</div>\n".
	"\t<div class='clr backendbottom'></div>\n".
	"\t<div class='push'></div>\n".
"</div>\n".
"</div>\n".
"<div class='footer_full'>\n".
	"\t<div class='footer'>\n".
		"\t\t<div class='footer_inner'>\n".
			"\t\t\t<p class='footerleft'>chillyCMS ";
			if ($showfooter) { echo $settings["version"]." "; }
			echo "&copy;2008 - ".date("Y").
			" Stefanie Wiegand &amp; Johannes Cox</p>\n";
			if ($showfooter) {
				echo "\t\t\t<p class='footerright'>".
				"<a href='http://".URL."/admin/credits.site.php'>More Credits</a></p>\n";
			}
		echo "\t\t</div>\n".
	"\t</div>\n".
"</div>\n".
"</body>\n".
"</html>\n";
} ?>
