<?php
//#################################################################################################
//	Mimetypes
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################

$mime_types = array(
"audio"		=> array(
		"au"	=> "audio/basic",
		"m3u"	=> "audio/x-mpegurl",
		"mid"	=> "audio/mid",
		"midi"	=> "audio/midi",
		"mp3"	=> "audio/mpeg",
		"ra"	=> "audio/x-pn-realaudio",
		"ram"	=> "audio/x-pn-realaudio",
		"rmi"	=> "audio/mid",
		"wav"	=> "audio/x-wav",
		),
"video"		=> array(
		"avi"	=> "video/x-msvideo",
		"flv"	=> "video/x-flv",
		"mov"	=> "video/quicktime",
		"mp2"	=> "video/mpeg",
		"mpa"	=> "video/mpeg",
		"mpe"	=> "video/mpeg",
		"mpeg"	=> "video/mpeg",
		"mpg"	=> "video/mpeg",
		"mpv2"	=> "video/mpeg",
		"qt"	=> "video/quicktime",
		),
"picture"	=> array(
		"bmp"	=> "image/bmp",
		"gif"	=> "image/gif",
		"ico"	=> "image/x-icon",
		"jpe"	=> "image/jpeg",
		"jpeg"	=> "image/jpeg",
		"jpg"	=> "image/jpeg",
		"png"	=> "image/png", 
		"svg"	=> "image/svg+xml",
		"tif"	=> "image/tiff",
		"tiff"	=> "image/tiff",
		),
"office"	=> array(
		"doc"	=> "application/msword",
		"dot"	=> "application/msword",
		"docx"	=> "application/vnd.openxmlformats-officedocument.wordprocessingml.document",
		"dotx"	=> "application/vnd.openxmlformats-officedocument.wordprocessingml.template",
		"docm"	=> "application/vnd.ms-word.document.macroEnabled.12",
		"dotm"	=> "application/vnd.ms-word.template.macroEnabled.12",
		"xls"	=> "application/vnd.ms-excel",
		"xlt"	=> "application/vnd.ms-excel",
		"xla"	=> "application/vnd.ms-excel",
		"xlsx"	=> "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet",
		"xltx"	=> "application/vnd.openxmlformats-officedocument.spreadsheetml.template",
		"xlsm"	=> "application/vnd.ms-excel.sheet.macroEnabled.12",
		"xltm"	=> "application/vnd.ms-excel.template.macroEnabled.12",
		"xlam"	=> "application/vnd.ms-excel.addin.macroEnabled.12",
		"xlsb"	=> "application/vnd.ms-excel.sheet.binary.macroEnabled.12",
		"ppt"	=> "application/vnd.ms-powerpoint",
		"pot"	=> "application/vnd.ms-powerpoint",
		"pps"	=> "application/vnd.ms-powerpoint",
		"ppa"	=> "application/vnd.ms-powerpoint",
		"pptx"	=> "application/vnd.openxmlformats-officedocument.presentationml.presentation",
		"potx"	=> "application/vnd.openxmlformats-officedocument.presentationml.template",
		"ppsx"	=> "application/vnd.openxmlformats-officedocument.presentationml.slideshow",
		"ppam"	=> "application/vnd.ms-powerpoint.addin.macroEnabled.12",
		"pptm"	=> "application/vnd.ms-powerpoint.presentation.macroEnabled.12",
		"potm"	=> "application/vnd.ms-powerpoint.template.macroEnabled.12",
		"ppsm"	=> "application/vnd.ms-powerpoint.slideshow.macroEnabled.12",
		"odt"	=> "application/vnd.oasis.opendocument.text",
		"ods"	=> "application/vnd.oasis.opendocument.spreadsheet",
		"odp"	=> "application/vnd.oasis.opendocument.presentation",
		"odg"	=> "application/vnd.oasis.opendocument.graphics",
		"odc"	=> "application/vnd.oasis.opendocument.chart",
		"odf"	=> "application/vnd.oasis.opendocument.formula",
		"odi"	=> "application/vnd.oasis.opendocument.image",
		"odm"	=> "application/vnd.oasis.opendocument.text-master",
		"ott"	=> "application/vnd.oasis.opendocument.text-template",
		"ots"	=> "application/vnd.oasis.opendocument.spreadsheet-template",
		"otp"	=> "application/vnd.oasis.opendocument.presentation-template",
		"otg"	=> "application/vnd.oasis.opendocument.graphics-template",
		),
"misc"		=> array(
		"exe"	=> "application/octet-stream",
		"vcf"	=> "text/x-vcard",
		),
"compressed"	=> array(
		"tar.gz"=> "application/x-compressed-tar",
		"7z"	=> "application/x-7z-compressed",
		"gtar"	=> "application/x-gtar",
		"gz"	=> "application/x-gzip",
		"rar"	=> "application/x-rar",
		"tar"	=> "application/x-tar",
		"tgz"	=> "application/x-compressed",
		"zip"	=> "application/zip",
		),
"document"	=> array(
		"ai"	=> "application/postscript",
		"dvi"	=> "application/x-dvi",
		"eps"	=> "application/postscript",
		"pdf"	=> "application/pdf",
		"ps"	=> "application/postscript",
		),
"text"		=> array(
		"css"	=> "text/css",
		"latex"	=> "application/x-latex",
		"rtf"	=> "application/rtf",
		"rtx"	=> "text/richtext",
		"tex"	=> "application/x-tex",
		"txt"	=> "text/plain",
		),	
);
?>
