<?php
//#################################################################################################
//	Page class
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################

if (file_exists("../config.php")) { require_once("../config.php"); }
else { require_once("../../config.php"); }
if (defined('DB_HOST')) {
	require_once(PATH."/core/settings.include.php");
	require_once(PATH."/languages/$settings[language].php");
}

abstract class Page {
	//Class variables//////////////////////////////////////////////////////////////////////////
	protected $doctype;
	protected $title;
	protected $meta;
	protected $stylesheets;
	protected $scripts;
	protected $content;

	protected $num_queries;
	protected $start_time;
	protected $stop_time;
	protected $load_time;

	//Functions////////////////////////////////////////////////////////////////////////////////
	//Constructor
	function __construct() {
		global $settings,$title;
		
		$this->num_queries	= 0;
		$this->start_time	= microtime(true);
		$this->stop_time	= false;
		$this->load_time	= false;

		//doctype
		$this->doctype = "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" ".
		"\"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n".
		"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"".$settings["language"]."\" ".
		"lang=\"".$settings["language"]."\">\n".
		"<head>\n";

		//metatags
		$this->meta = "\t<meta http-equiv=\"Content-Type\" content=\"text/html;charset=iso-8859-1\" />\n".
		"\t<meta name=\"Content-Language\" content=\"".$settings["language"]."\" />\n";
		
		//to be filled in child classes
		$this->title = $this->stylesheets = $this->scripts = $this->content = "";
	}
	//Destructor
	function __destruct() {
		$this->doctype = $this->title = $this->meta = $this->stylesheets = $this->scripts = $this->num_queries =
		$this->start_time = $this->stop_time = $this->load_time = false;	
	}
	//add something to the page content
	public function add($string) {
		if ($this->content .= $string) {
			return true;
		} else {
			return false;
		}
	}
	//simulate a query being executed
	public function query() {
		if ($this->num_queries += 1) {
			return true;
		} else {
			return false;
		}
	}
} ?>
