<?php
//#################################################################################################
//	Webuser class
//#################################################################################################
//	chillyCMS - Content Management System
//	Copyright (C) 2008
//	Stefanie Wiegand <wiegand.stefanie@gmail.com> & Johannes Cox <johannes.cox@gmail.com>
//	
//	This program is licensed under the GPL 3.0 license. For more information see LICENSE.txt.
//#################################################################################################

class Webuser {
	//Class variables//////////////////////////////////////////////////////////////////////////
	private $agent;			//User agent
	private $browser;
	private $browserversion;
	private $ip;
	private $os;
	private $referer;		//the site the visitor came from
	private $country;
	private $isbot;
	//Functions////////////////////////////////////////////////////////////////////////////////
	//Constructor
	public function __construct() {
		global $l_ctr;
		
		$this->isbot=false;
		if (preg_match('/slurp|inktomisearch|[Gg]rub|[Bb]ot|archiver|[Ss]qworm/', $_SERVER['HTTP_USER_AGENT'])) {
			$this->browser=$this->browserversion=$this->os=$this->country="Bot";
			$this->isbot=true;
		} else {
			$mail=false;
			//browser
			$browsers = array("firefox","opera","chrome","safari","seamonkey","konqueror","k-meleon",
			"msie 6.0","msie 7.0","msie 8.0","msie","epiphany",
			"netscape","gecko","navigator","mosaic","lynx","amaya","omniweb","avant","camino","flock","aol","mozilla");
			$this->agent = strtolower($_SERVER["HTTP_USER_AGENT"]);
			$found=0;
			foreach($browsers as $browser) {
				if (preg_match("#($browser)[/ ]?([0-9.]*)#", $this->agent, $match)) {
					$this->browser = $match[1] ;
					$this->browserversion = $match[2] ;
					$found++;
					break;
				}
			}
			if ($found==0) {
				$this->browser = "unknown";
				$this->browserversion = "0.0.0";
				$mail=true;
			}
			//ip
			$this->ip = $_SERVER['REMOTE_ADDR'];
			//os
			if (strstr($_SERVER["HTTP_USER_AGENT"], "windows 95")) { $this->os = "Windows 95"; }
			elseif (strstr($this->agent, "windows 98")) { $this->os = "Windows 98"; }
			elseif (strstr($this->agent, "nt 4.0")) { $this->os = "Windows NT"; }
			elseif (strstr($this->agent, "nt 5.0")) { $this->os = "Windows 2000"; }
			elseif (strstr($this->agent, "nt 5.1")) { $this->os = "Windows XP"; }
			elseif (strstr($this->agent, "nt 6.0")) { $this->os = "Windows Vista"; }
			elseif (strstr($this->agent, "nt 6.1")) { $this->os = "Windows 7"; }
			elseif (strstr($this->agent, "win")) { $this->os = "Windows"; }
			elseif (strstr($this->agent, "iphone")) { $this->os = "iPhone"; }
			elseif (strstr($this->agent, "mac")) { $this->os = "MacOS"; }
			elseif (strstr($this->agent, "linux")) {
				if (strstr($this->agent, "ubuntu")) { $this->os = "Ubuntu"; }
				elseif (strstr($this->agent, "debian")) { $this->os = "Debian"; }
				elseif (strstr($this->agent, "fedora")) { $this->os = "Fedora"; }
				elseif (strstr($this->agent, "mint")) { $this->os = "Linux Mint"; }
				elseif (strstr($this->agent, "kubuntu")) { $this->os = "Kubuntu"; }
				elseif (strstr($this->agent, "opensuse")) { $this->os = "openSUSE"; }
				elseif (strstr($this->agent, "mandriva")) { $this->os = "Mandriva"; }
				elseif (strstr($this->agent, "gentoo")) { $this->os = "Gentoo"; }
				elseif (strstr($this->agent, "arch")) { $this->os = "Arch"; }
				elseif (strstr($this->agent, "slackware")) { $this->os = "Slackware"; }
				else { $this->os = "Linux"; }
			}
			elseif (strstr($this->agent, "freebsd")) { $this->os = "FreeBSD"; }
			elseif (strstr($this->agent, "openbsd")) { $this->os = "OpenBSD"; }
			elseif (strstr($this->agent, "sunos")) { $this->os = "SunOS"; }
			elseif (strstr($this->agent, "irix")) { $this->os = "IRIX"; }
			elseif (strstr($this->agent, "beos")) { $this->os = "BeOS"; }
			elseif (strstr($this->agent, "os/2")) { $this->os = "OS/2"; }
			elseif (strstr($this->agent, "aix")) { $this->os = "AIX"; }
			elseif (strstr($this->agent, "unix")) { $this->os = "Unix"; }
			elseif (strstr($this->agent, "dos")) { $this->os = "DOS"; }
			else { $this->os = "unknown"; $mail=true; }
			//referer
			if (isset($_SERVER['HTTP_REFERER'])) { $this->referer = $_SERVER['HTTP_REFERER']; }
			else { $this->referer = "unknown"; }
			//country
			$countries = array(
			"af"	=> "ZA",	"ar-ae"	=> "UAE",	"ar-bh"	=> "BAH",	"ar-dz"	=> "ALG",
			"ar-eg"	=> "EGY",	"ar-iq"	=> "IRQ",	"ar-jo"	=> "JOR",	"ar-kw"	=> "KUW",
			"ar-lb"	=> "LEB",	"ar-ly"	=> "LIB",	"ar-ma"	=> "MAR",	"ar-om"	=> "OM",
			"ar-qa"	=> "QAT",	"ar-sa"	=> "SA",	"ar-sy"	=> "SYR",	"ar-tn"	=> "TUN",
			"ar-ye"	=> "YEM",	"ar"	=> "AR",	"as"	=> "ASS",	"az"	=> "IRN",
			"be"	=> "BE",	"bg"	=> "BG",	"bn"	=> "BEN",	"ca"	=> "CAT",
			"cs"	=> "CZ",	"da"	=> "DK",	"de-at"	=> "AU",	"de-ch"	=> "CH",
			"de-li"	=> "LIE",	"de-lu"	=> "LUX",	"de"	=> "DE",	"div"	=> "MALE",
			"el"	=> "GR",	"en-au"	=> "AUS",	"en-bz"	=> "BLZ",	"en-ca"	=> "CAN",
			"en-gb"	=> "UK",	"en-ie"	=> "IRL",	"en-jm"	=> "JAM",	"en-nz"	=> "NZ",
			"en-ph"	=> "PHI",	"en-tt"	=> "TRI",	"en-us"	=> "USA",	"en-za"	=> "ZA",
			"en-zw"	=> "ZIM",	"en"	=> "CAR",	"es-ar"	=> "ARG",	"es-bo"	=> "BOL",
			"es-cl"	=> "CHI",	"es-co"	=> "COL",	"es-cr"	=> "COR",	"es-do"	=> "DOM",
			"es-ec"	=> "ECU",	"es-es"	=> "E",		"es-gt"	=> "GUA",	"es-hn"	=> "HON",
			"es-mx"	=> "MX",	"es-ni"	=> "NIC",	"es-pa"	=> "PAN",	"es-pe"	=> "PRU",
			"es-pr"	=> "PUE",	"es-py"	=> "PAR",	"es-sv"	=> "SAL",	"es-us"	=> "USA",
			"es-uy"	=> "URU",	"es-ve"	=> "VEN",	"es"	=> "E",		"et"	=> "EST",
			"eu"	=> "BAS",	"fa"	=> "PER",	"fi"	=> "FIN",	"fo"	=> "FAE",
			"fr-be"	=> "BE",	"fr-ca"	=> "CAN",	"fr-ch"	=> "CH",	"fr-lu"	=> "LUX",
			"fr-mc"	=> "MON",	"fr"	=> "FR",	"ga"	=> "IRL",	"gd"	=> "SCO",
			"gu"	=> "IN",	"he"	=> "ISR",	"hi"	=> "IN",	"hr"	=> "HR",
			"hu"	=> "HU",	"hy"	=> "ARM",	"id"	=> "IND",	"is"	=> "ICE",
			"it"	=> "IT",	"it-ch"	=> "CH",	"ja"	=> "JAP",	"ji"	=> "ISR",
			"ka"	=> "GEO",	"kk"	=> "KZS",	"kn"	=> "IN",	"ko"	=> "KOR",
			"kok"	=> "IN",	"kz"	=> "KIR",	"lv"	=> "LAT",	"ls"	=> "SLE",
			"lt"	=> "LIT",	"mk"	=> "MAK",	"ml"	=> "IN",	"mn"	=> "MONG",
			"mr"	=> "IN",	"ms"	=> "MAL",	"mt"	=> "MALT",	"nb-no"	=> "NOR",
			"ne"	=> "NEP",	"nl-be"	=> "BE",	"nl"	=> "NL",	"nn-no"	=> "NOR",
			"no"	=> "NOR",	"or"	=> "IN",	"pa"	=> "IN",	"pl"	=> "PL",
			"pt-br"	=> "BR",	"pt"	=> "PTG",	"rm"	=> "CH",	"ro-mo"	=> "MOL",
			"ro"	=> "RO",	"ru-mo"	=> "MOL",	"ru"	=> "RU",	"sa"	=> "IN",
			"sb"	=> "SER",	"sk"	=> "SLA",	"sl"	=> "SLE",	"sq"	=> "ALB",
			"sr"	=> "SER",	"sv-fi"	=> "FIN",	"sv"	=> "SWE",	"sw"	=> "EA",
			"sx"	=> "ZA",	"syr"	=> "SYR",	"sz"	=> "LAP",	"ta"	=> "IN",
			"te"	=> "IN",	"th"	=> "THA",	"tn"	=> "BOT",	"tr"	=> "TR",
			"ts"	=> "ZA",	"tt"	=> "RU",	"uk"	=> "UKR",	"ur"	=> "PAK",
			"uz"	=> "UZB",	"ve"	=> "ZA",	"vi"	=> "VI",	"xh"	=> "ZA",
			"yi"	=> "ISR",	"zh-cn"	=> "CN",	"zh-hk"	=> "HK",	"zh-mo"	=> "MAC",
			"zh-sg"	=> "SIN",	"zh-tw"	=> "TAI",	"zh"	=> "CN",	"zu"	=> "ZA",
			);
			$this->country = strtolower($_SERVER["HTTP_ACCEPT_LANGUAGE"]);
			$found=0;
			$maybecountries=array();
			foreach($countries as $key=>$country) {
				if (strstr($this->country,$key)) {
					$this->country = $country;
					$found++;
					break;
				}
			}
			if ($found==0) { $this->country = "unknown"; $mail=true; }
			//Was there something unidentifiable?
			if ($mail) {
				//echo "new data!";
				$to=$settings["siteemail"];
				$subject="New HTTP_USER_AGENT found!";
				$mailmsg="User agent: $this->agent<br />Language: $_SERVER[HTTP_ACCEPT_LANGUAGE]";
				$header = "MIME-Version: 1.0'\r\n";
				$header.= "Content-type: text/html; charset=iso-8859-1\r\n";
				$header.= "From: ".$this->pagetitle.": chillyCMS> <$email>\r\n";
				mail($to, $subject, $mailmsg, $header);
			}
		}
	}
	//Getter
	public function __get($name) {
		if (isset($name, $this->$name)) { return $this->$name; }
		else { return false; }	
	}
}
?>
